﻿// ECMAScript 5 strict mode
"use strict";

assert2(cr, "cr namespace not created");
assert2(cr.plugins_, "cr.plugins_ not created");

/////////////////////////////////////
// Plugin class
cr.plugins_.ppstudiomty_kong_plugin = function(runtime)
{
	this.runtime = runtime;
	//console.log(runtime);
	//console.log(cr.plugins_.ppstudiomty_kong_plugin.runtime);
};

(function ()
{
	///////////////////////////////////////
	var XMLHttp = function(){};

	XMLHttp.comm = {};

	XMLHttp.RequestFile = function(url,onComplete,onError){
			
			XMLHttp.comm = new XMLHttpRequest();
			
			//console.log(XMLHttp.comm);
			XMLHttp.comm.open("GET",url,true);
			XMLHttp.comm.onreadystatechange = function(){
				
				//console.log(this.readyState+" "+this.status);
				if (this.readyState==4 && this.status ==200){
					if (onComplete!=="undefined")
						onComplete(this.responseText);
				}
				else if (this.status!=200){
					if (onError)
						onError(this.status);
				}
			}
			XMLHttp.comm.send();
	};	
	
	///////////////////////////////////////
	var pluginProto = cr.plugins_.ppstudiomty_kong_plugin.prototype;
		
	/////////////////////////////////////
	// Object type class
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};

	var typeProto = pluginProto.Type.prototype;

	typeProto.onCreate = function()
	{
	};

	/////////////////////////////////////
	// Instance class
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		this.kongAPI = ["kongregateAPI"];
		this.responseText = "";
		this.playerInfo = "";
		this.responseReady = false;
	
		// Initialise object properties
		//this.testProperty = 0;
	};
	
	var instanceProto = pluginProto.Instance.prototype;
	
	instanceProto.onCreate = function()
	{
		
		console.log("Kongregate API in process...");
		// Read properties set in C3
		//this.apiID = this.properties[0]; <-- Deprecated
		
		//if (typeof ["kongregateAPI"] === "undefined"){
		if (typeof this.kongAPI === "undefined"){
			console.log("Kongregate API NOT loaded");
			this.kongLoaded = false;
		}
		else{
			console.log("Kongregate API Found");
			console.log(this.kongAPI);
			this.kongLoaded = true;
		}

		window["kongregateAPI"]["loadAPI"](function(){
				window.kongregate = window["kongregateAPI"]["getAPI"]();//this.kongAPI["getAPI"]();
				// You can now access the Kongregate API with:
				// kongregate.services.getUsername(), etc
				// Proceed with loading your game...
				
				window.kongregate["services"]["addEventListener"]("login", 
						()=>{
							self.Trigger(C3.Plugins.ppstudiomty_kong_plugin.Cnds.OnLogin);
						}
					);
			});
			
		console.log("Callback function for loading API...");
	};
	
	instanceProto.saveToJSON = function ()
	{
		return {};
	};
	
	instanceProto.loadFromJSON = function (o)
	{
	};
	
	/*instanceProto.parseUserInfo = function (t)
	{
		this.playerInfo = JSON.parse(t);
		this.responseReady = true;
		console.log(this.playerInfo["user_vars"]["avatar_url"]);
		//alert(this.playerInfo["username"]);
	};*/
	
	/**BEGIN-PREVIEWONLY**/
	instanceProto.getDebuggerValues = function (propsections)
	{
	};
	/**END-PREVIEWONLY**/

	//////////////////////////////////////
	// Conditions
	function Cnds() {};
	
	Cnds.prototype.IsAPILoaded = function ()
	{
		return this.kongLoaded;
		/*if (typeof kongregateAPI.getAPI() === "undefined")
			return false;
		else
			return true;*/
	};
	
	Cnds.prototype.IsGuest = function (){
		let g=window.kongregate["services"]["isGuest"]();
		
		return g;
	};
	
	Cnds.prototype.IsPlayerInfoReady = function (){
		//console.log("IsPlayerInfoReady Called");
		return true;
	};
	
	Cnds.prototype.OnInfoError = function () {
		//console.log("OnInfoError Called");
		return true;
	};
	
	Cnds.prototype.OnAPILoaded = function(){
		return true;
	};
	
	pluginProto.cnds = new Cnds();

	//////////////////////////////////////
	// Actions
	function Acts() {};

	Acts.prototype.SubmitScore = function (stat,val)
	{
		window.kongregate["stats"]["submit"](stat, val);
	};
		
	Acts.prototype.RequestUserInfo = function (username)
	{
		this.responseReady = false;
		//console.log("Requesting INFO of "+username);
		//console.log(this.runtime);
		let self=this;
		XMLHttp.RequestFile("https://api.kongregate.com/api/user_info.json?username="+username+"&friends=true",
				function(t){
					//console.log("All OK");
					self.responseText = t;
					//self.parseUserInfo(t);
					self.playerInfo = JSON.parse(t);
					self.responseReady = true;
					self.runtime.trigger(cr.plugins_.ppstudiomty_kong_plugin.prototype.cnds.IsPlayerInfoReady,self)
					},
				function(){
					//console.log("Error occurred");
					self.runtime.trigger(cr.plugins_.ppstudiomty_kong_plugin.prototype.cnds.OnInfoError,self);
					}
			);
	};
	
	Acts.prototype.ShowRegistrationBox = function (){
		window.kongregate["services"]["showRegistrationBox"]();
	}
	
	Acts.prototype.SubmitAvatar = function (object){
		//window.btoa(data);
		console.log(object);
		console.log(object.plugin);
		console.log(object.plugin.type);
	}
	
	pluginProto.acts = new Acts();

	//////////////////////////////////////
	// Expressions
	function Exps() {};
	
	/*Exps.prototype.Double = function (ret, number)
	{
		ret.set_float(number * 2);
	};*/
	
    Exps.prototype.GetUserName = function (ret) {
        let user = window.kongregate["services"]["getUsername"]();
        ret.set_string(user || "");
    };
	
	Exps.prototype.GetAuthToken = function(ret) {
		let token=window.kongregate["services"]["getGameAuthToken"]();
		ret.set_string(token || "");
	};
	
	Exps.prototype.GetUserId = function(ret){
		let id=window.kongregate["services"]["getUserId"]();
		ret.set_string(id || "");
	}

	Exps.prototype.GetAPIId = function(ret){
		ret.set_string(this.apiID || "");
	}
	
	Exps.prototype.GetResponseString = function (ret){
		ret.set_string(this.responseText||"");
	}
		
	Exps.prototype.GetAvatarURL = function (ret,ob){
		console.log(ob);
		if (this.responseReady){
			ret.set_string(this.playerInfo["user_vars"]["avatar_url"]||"");
		}
		else
			ret.set_string("");
	}

	Exps.prototype.GetPlayerLevel = function (ret){
		if (this.responseReady)
			ret.set_int(this.playerInfo["user_vars"]["level"]||0);
		else
			ret.set_int(0);
	}
	
	Exps.prototype.GetPlayerPoints = function (ret){
		if (this.responseReady)
			ret.set_int(this.playerInfo["user_vars"]["points"]||0);
		else
			ret.set_int(0);		
	}
	
	pluginProto.exps = new Exps();

}());